app/models/preferences.py
# -*- coding: UTF-8 -*

"""Model : preferences
"""

from app import db


class ScoPreference(db.Model):
    """ScoDoc preferences (par département)"""

    __tablename__ = "sco_prefs"
    id = db.Column(db.Integer, primary_key=True)
    pref_id = db.synonym("id")

    dept_id = db.Column(db.Integer, db.ForeignKey("departement.id"))

    name = db.Column(db.String(128), nullable=False, index=True)
    value = db.Column(db.Text())
    formsemestre_id = db.Column(db.Integer, db.ForeignKey("notes_formsemestre.id"))

    def __repr__(self):
        return f"<{self.__class__.__name__} {self.id} {self.departement.acronym} {self.name}={self.value}>"

app/entreprises/__init__.py
"""entreprises.__init__
"""

from datetime import datetime
from flask import Blueprint
from app.scodoc import sco_etud
from app.auth.models import User
from app.models import Departement
import app.scodoc.sco_utils as scu

bp = Blueprint("entreprises", __name__)

LOGS_LEN = 5
SIRET_PROVISOIRE_START = "xx"


@bp.app_template_filter()
def format_prenom(s):
    return scu.format_prenom(s)


@bp.app_template_filter()
def format_nom(s):
    return scu.format_nom(s)


@bp.app_template_filter()
def get_nomcomplet_by_username(s):
    user = User.query.filter_by(user_name=s).first()
    return user.get_nomcomplet()


@bp.app_template_filter()
def get_nomcomplet_by_id(id):
    user = User.query.filter_by(id=id).first()
    return user.get_nomcomplet()


@bp.app_template_filter()
def get_dept_acronym(id):
    dept = Departement.query.filter_by(id=id).first()
    return dept.acronym


@bp.app_template_filter()
def get_civilité(civ):
    if civ == "H":
        return "Monsieur"
    else:
        return "Madame"


@bp.app_template_filter()
def check_taxe_now(taxes):
    for taxe in taxes:
        if taxe.annee == int(datetime.now().strftime("%Y")):
            return True
    return False


from app.entreprises import routes

app/entreprises/routes.py
import os
from datetime import datetime
import glob
import shutil

from flask import render_template, redirect, url_for, request, flash, send_file, abort
from flask_json import as_json
from flask_login import current_user
from sqlalchemy import text, sql
from werkzeug.utils import secure_filename

from app.decorators import permission_required

from app.entreprises import LOGS_LEN, SIRET_PROVISOIRE_START
from app.entreprises.forms import (
    ActivationConfirmationForm,
    CorrespondantsCreationForm,
    DesactivationConfirmationForm,
    EntrepriseCreationForm,
    EntrepriseModificationForm,
    EntreprisesFilterForm,
    SiteCreationForm,
    SiteModificationForm,
    SuppressionConfirmationForm,
    OffreCreationForm,
    OffreModificationForm,
    CorrespondantModificationForm,
    ContactCreationForm,
    ContactModificationForm,
    StageApprentissageCreationForm,
    EnvoiOffreForm,
    AjoutFichierForm,
    TaxeApprentissageForm,
    TaxeApprentissageModificationForm,
    ValidationConfirmationForm,
    ImportForm,
    PreferencesForm,
)
from app.entreprises import bp
from app.entreprises.models import (
    Entreprise,
    EntrepriseOffre,
    EntrepriseCorrespondant,
    EntrepriseHistorique,
    EntrepriseContact,
    EntrepriseSite,
    EntrepriseStageApprentissage,
    EntrepriseEnvoiOffre,
    EntrepriseOffreDepartement,
    EntreprisePreferences,
    EntrepriseTaxeApprentissage,
)
from app.entreprises import app_relations_entreprises as are
from app.models import Identite
from app.auth.models import User
from app.scodoc.sco_permissions import Permission
from app.scodoc import sco_etud, sco_excel
import app.scodoc.sco_utils as scu

from app import db
from config import Config


@bp.route("/", methods=["GET", "POST"])
@permission_required(Permission.RelationsEntrepView)
def index():
    """
    Permet d'afficher une page avec la liste des entreprises (visible et active) et une liste des dernières opérations
    """
    entreprises = Entreprise.query.filter_by(visible=True, active=True)
    logs = (
        EntrepriseHistorique.query.order_by(EntrepriseHistorique.date.desc())
        .limit(LOGS_LEN)
        .all()
    )
    form = EntreprisesFilterForm()
    checked = [False, False, False]
    if request.method == "POST":
        checked = [form.active.data, form.association.data, form.siret_provisoire.data]
    if checked[0]:
        entreprises = Entreprise.query.filter_by(visible=True)
    if checked[1]:
        entreprises = Entreprise.query.filter_by(visible=True, association=True)
    if checked[2]:
        entreprises = Entreprise.query.filter_by(visible=True, siret_provisoire=True)
    if checked[1] and checked[2]:
        entreprises = Entreprise.query.filter_by(
            visible=True, association=True, siret_provisoire=True
        )
    return render_template(
        "entreprises/entreprises.j2",
        title="Entreprises",
        entreprises=entreprises,
        logs=logs,
        form=form,
        checked=checked,
    )


@bp.route("/logs", methods=["GET"])
@permission_required(Permission.RelationsEntrepView)
def logs():
    """
    Permet d'afficher les logs (toutes les entreprises)
    """
    page = request.args.get("page", 1, type=int)
    logs = EntrepriseHistorique.query.order_by(
        EntrepriseHistorique.date.desc()
    ).paginate(page=page, per_page=20)
    return render_template(
        "entreprises/logs.j2",
        title="Logs",
        logs=logs,
    )


@bp.route("/correspondants", methods=["GET"])
@permission_required(Permission.RelationsEntrepViewCorrs)
def correspondants():
    """
    Permet d'afficher une page avec la liste des correspondants des entreprises visibles et une liste des dernières opérations
    """
    correspondants = (
        db.session.query(EntrepriseCorrespondant, EntrepriseSite)
        .join(EntrepriseSite, EntrepriseCorrespondant.site_id == EntrepriseSite.id)
        .join(Entreprise, EntrepriseSite.entreprise_id == Entreprise.id)
        .filter_by(visible=True, active=True)
        .all()
    )
    logs = (
        EntrepriseHistorique.query.order_by(EntrepriseHistorique.date.desc())
        .limit(LOGS_LEN)
        .all()
    )
    return render_template(
        "entreprises/correspondants.j2",
        title="Correspondants",
        correspondants=correspondants,
        logs=logs,
    )


@bp.route("/validation", methods=["GET"])
@permission_required(Permission.RelationsEntrepValidate)
def validation():
    """
    Permet d'afficher une page avec la liste des entreprises a valider (non visible)
    """
    entreprises = Entreprise.query.filter_by(visible=False).all()
    return render_template(
        "entreprises/entreprises_validation.j2",
        title="Validation entreprises",
        entreprises=entreprises,
    )


@bp.route("/fiche_entreprise_validation/<int:entreprise_id>", methods=["GET"])
@permission_required(Permission.RelationsEntrepValidate)
def fiche_entreprise_validation(entreprise_id):
    """
    Permet d'afficher la fiche entreprise d'une entreprise a valider
    """
    entreprise = Entreprise.query.filter_by(
        id=entreprise_id, visible=False
    ).first_or_404(
        description=f"fiche entreprise (validation) {entreprise_id} inconnue"
    )
    return render_template(
        "entreprises/fiche_entreprise_validation.j2",
        title="Validation fiche entreprise",
        entreprise=entreprise,
    )


@bp.route(
    "/fiche_entreprise_validation/<int:entreprise_id>/validate_entreprise",
    methods=["GET", "POST"],
)
@permission_required(Permission.RelationsEntrepValidate)
def validate_entreprise(entreprise_id):
    """
    Permet de valider une entreprise
    """
    form = ValidationConfirmationForm()
    entreprise = Entreprise.query.filter_by(
        id=entreprise_id, visible=False
    ).first_or_404(description=f"entreprise (validation) {entreprise_id} inconnue")
    if request.method == "POST" and form.cancel.data:
        return redirect(
            url_for(
                "entreprises.fiche_entreprise_validation", entreprise_id=entreprise_id
            )
        )
    if form.validate_on_submit():
        entreprise.visible = True
        nom_entreprise = f"<a href=/ScoDoc/entreprises/fiche_entreprise/{entreprise.id}>{entreprise.nom}</a>"
        log = EntrepriseHistorique(
            authenticated_user=current_user.user_name,
            entreprise_id=entreprise.id,
            text=f"{nom_entreprise} - Validation de la fiche entreprise ({entreprise.nom})",
        )
        db.session.add(log)
        db.session.commit()
        flash("L'entreprise a été validé et ajouté à la liste.")
        return redirect(url_for("entreprises.validation"))
    return render_template(
        "entreprises/form_validate_confirmation.j2",
        title="Validation entreprise",
        form=form,
    )


@bp.route(
    "/fiche_entreprise_validation/<int:entreprise_id>/delete_validation_entreprise",
    methods=["GET", "POST"],
)
@permission_required(Permission.RelationsEntrepValidate)
def delete_validation_entreprise(entreprise_id):
    """
    Permet de supprimer une entreprise en attente de validation avec une formulaire de validation
    """
    entreprise = Entreprise.query.filter_by(
        id=entreprise_id, visible=False
    ).first_or_404(description=f"entreprise (validation) {entreprise_id} inconnue")
    form = SuppressionConfirmationForm()
    if request.method == "POST" and form.cancel.data:
        return redirect(
            url_for(
                "entreprises.fiche_entreprise_validation", entreprise_id=entreprise_id
            )
        )
    if form.validate_on_submit():
        db.session.delete(entreprise)
        db.session.commit()
        log = EntrepriseHistorique(
            authenticated_user=current_user.user_name,
            entreprise_id=entreprise.id,
            text=f"Non validation de la fiche entreprise ({entreprise.nom})",
        )
        db.session.add(log)
        flash("L'entreprise a été supprimée de la liste des entreprises à valider.")
        return redirect(url_for("entreprises.validation"))
    return render_template(
        "form_confirmation.j2",
        title="Supression entreprise",
        form=form,
        info_message="Cliquez sur le bouton Supprimer pour confirmer votre supression",
    )


@bp.route("/offres_recues", methods=["GET"])
@permission_required(Permission.RelationsEntrepView)
def offres_recues():
    """
    Permet d'afficher la page où l'on peut voir les offres reçues
    """
    offres_recues = (
        db.session.query(EntrepriseEnvoiOffre, EntrepriseOffre)
        .filter(EntrepriseEnvoiOffre.receiver_id == current_user.id)
        .join(EntrepriseOffre, EntrepriseOffre.id == EntrepriseEnvoiOffre.offre_id)
        .all()
    )
    offres_recues_with_files = []
    for envoi_offre, offre in offres_recues:
        correspondant = EntrepriseCorrespondant.query.filter_by(
            id=offre.correspondant_id
        ).first()
        files = []
        path = os.path.join(
            Config.SCODOC_VAR_DIR,
            "entreprises",
            f"{offre.entreprise_id}",
            f"{offre.id}",
        )
        if os.path.exists(path):
            for dir in glob.glob(
                f"{path}/[0-9][0-9][0-9][0-9]-[0-9][0-9]-[0-9][0-9]-[0-9][0-9]-[0-9][0-9]-[0-9][0-9]"
            ):
                for file in glob.glob(f"{dir}/*"):
                    file = [os.path.basename(dir), os.path.basename(file)]
                    files.append(file)
        offres_recues_with_files.append([envoi_offre, offre, files, correspondant])
    return render_template(
        "entreprises/offres_recues.j2",
        title="Offres reçues",
        offres_recues=offres_recues_with_files,
    )


@bp.route(
    "/offres_recues/delete_offre_recue/<int:envoi_offre_id>", methods=["GET", "POST"]
)
@permission_required(Permission.RelationsEntrepView)
def delete_offre_recue(envoi_offre_id):
    """
    Permet de supprimer une offre reçue

app/templates/entreprises/entreprises.j2
{# -*- mode: jinja-html -*- #}
{% extends 'base.j2' %}

{% block styles %}
{{super()}}
<script src="/ScoDoc/static/jQuery/jquery-1.12.4.min.js"></script>
<link rel="stylesheet" type="text/css" href="/ScoDoc/static/DataTables/datatables.min.css">
<script type="text/javascript" charset="utf8" src="/ScoDoc/static/DataTables/datatables.min.js"></script>
{% endblock %}

{% block app_content %}
{% include 'entreprises/nav.j2' %}

{% if logs %}
<div class="container">
    <h3>Dernières opérations <a href="{{ url_for('entreprises.logs') }}">Voir tout</a></h3>
    <ul>
        {% for log in logs %}
        <li><span style="margin-right: 10px;">{{ log.date.strftime('%d %b %Hh%M') }}</span><span>{{ log.text|safe }} par
                {{ log.authenticated_user|get_nomcomplet_by_username }}</span></li>
        {% endfor %}
    </ul>
</div>
{% endif %}

<div class="container boutons">
    {% if current_user.has_permission(current_user.Permission.RelationsEntrepEdit, None) %}
    <a class="btn btn-default" href="{{ url_for('entreprises.add_entreprise') }}">Ajouter une entreprise</a>
    {% endif %}
    {% if current_user.has_permission(current_user.Permission.RelationsEntrepExport, None) %}
    <a class="btn btn-default" href="{{ url_for('entreprises.import_donnees') }}">Importer des données</a>
    {% endif %}
    {% if current_user.has_permission(current_user.Permission.RelationsEntrepExport, None) and entreprises %}
    <a class="btn btn-default" href="{{ url_for('entreprises.export_donnees') }}">Exporter des données</a>
    {% endif %}
</div>

<div class="container" style="margin-bottom: 10px;">
    <h1>Liste des entreprises</h1>
    {% if form %}
    <form id="form-entreprise-filter" method="POST" action="">
        {{ form.hidden_tag() }}
        <div><input id="active" name="active" type="checkbox" onChange="form.submit()" {% if checked[0] %} checked {%
                endif %}> {{ form.active.label }}</div>
        <div><input id="association" name="association" type="checkbox" onChange="form.submit()" {% if checked[1] %}
                checked {% endif %}> {{ form.association.label }}</div>
        <div><input id="siret_provisoire" name="siret_provisoire" type="checkbox" onChange="form.submit()" {% if
                checked[2] %} checked {% endif %}> {{ form.siret_provisoire.label }}</div>
    </form>
    {% endif %}
    <table id="table-entreprises">
        <thead>
            <tr>
                <td data-priority="2">SIRET</td>
                <td data-priority="1">Nom</td>
                <td data-priority="4">Adresse</td>
                <td data-priority="6">Code postal</td>
                <td data-priority="5">Ville</td>
                <td data-priority="7">Pays</td>
                {% if current_user.has_permission(current_user.Permission.RelationsEntrepEdit, None) %}
                <td data-priority="3">Action</td>
                {% endif %}
            </tr>
        </thead>
        <tbody>
            {% for entreprise in entreprises %}
            <tr>
                <td><a href="{{ url_for('entreprises.fiche_entreprise', entreprise_id=entreprise.id) }}"
                        style="{% if not entreprise.active %}color:red;{% endif %}{% if entreprise.siret_provisoire %}font-weight:bold;{% endif %}">{{
                        entreprise.siret }}</a></td>
                <td>{{ entreprise.nom }}</td>
                <td>{{ entreprise.adresse }}</td>
                <td>{{ entreprise.codepostal }}</td>
                <td>{{ entreprise.ville }}</td>
                <td>{{ entreprise.pays }}</td>
                {% if current_user.has_permission(current_user.Permission.RelationsEntrepEdit, None) %}
                <td>
                    <div class="btn-group">
                        <a class="btn btn-default dropdown-toggle" data-toggle="dropdown" href="#">Action
                            <span class="caret"></span>
                        </a>
                        <ul class="dropdown-menu pull-left">
                            <li><a
                                    href="{{ url_for('entreprises.edit_entreprise', entreprise_id=entreprise.id) }}">Modifier</a>
                            </li>
                            {% if entreprise.active %}
                            <li><a href="{{ url_for('entreprises.fiche_entreprise_desactiver', entreprise_id=entreprise.id)}}"
                                    style="color:red">Désactiver</a></li>
                            {% else %}
                            <li><a href="{{ url_for('entreprises.fiche_entreprise_activer', entreprise_id=entreprise.id)}}"
                                    style="color:lightgreen">Activer</a></li>
                            {% endif %}
                        </ul>
                    </div>
                </td>
                {% endif %}
            </tr>
            {% endfor %}
        </tbody>
        <tfoot>
            <tr>
                <td>SIRET</td>
                <td>Nom</td>
                <td>Adresse</td>
                <td>Code postal</td>
                <td>Ville</td>
                <td>Pays</td>
                {% if current_user.has_permission(current_user.Permission.RelationsEntrepEdit, None) %}
                <td>Action</td>
                {% endif %}
            </tr>
        </tfoot>
    </table>
</div>

<script>
    document.addEventListener('DOMContentLoaded', function () {
        let table = new DataTable('#table-entreprises',
            {
                "autoWidth": false,
                "responsive": {
                    "details": true
                },
                "pageLength": 10,
                "language": {
                    "emptyTable": "Aucune donnée disponible dans le tableau",
                    "info": "Affichage de _START_ à _END_ sur _TOTAL_ entrées",
                    "infoEmpty": "Affichage de 0 à 0 sur 0 entrées",
                    "infoFiltered": "(filtrées depuis un total de _MAX_ entrées)",
                    "lengthMenu": "Afficher _MENU_ entrées",
                    "loadingRecords": "Chargement...",
                    "processing": "Traitement...",
                    "search": "Rechercher:",
                    "zeroRecords": "Aucune entrée correspondante trouvée",
                    "paginate": {
                        "next": "Suivante",
                        "previous": "Précédente"
                    }
                }
            });
    });
</script>
{% endblock %}

app/templates/entreprises/form_validate_confirmation.j2
{# -*- mode: jinja-html -*- #}
{% extends 'base.j2' %}
{% import 'wtf.j2' as wtf %}

{% block app_content %}
<h1>Validation entreprise</h1>
<br>
<div style="color:green;">Cliquez sur le bouton Valider pour confirmer votre validation</div>
<br>
<div class="row">
    <div class="col-md-4">
        {{ wtf.quick_form(form) }}
    </div>
</div>
{% endblock %}

app/templates/entreprises/logs.j2
{# -*- mode: jinja-html -*- #}
{% extends 'base.j2' %}

{% block app_content %}
<div class="container">
    <ul class="breadcrumbs">
        <li class="breadcrumbs_item">
            <a href="{{ url_for('entreprises.index') }}" class="breadcrumbs_link">Entreprises</a>
        </li>
        <li class="breadcrumbs_item">
            <a href="" class="breadcrumbs_link breadcrumbs_link-active">Dernières opérations</a>
        </li>
    </ul>
</div>

<div class="container">
    <h3>Dernières opérations</h3>
    {% if logs.items %}
    <ul>
        {% for log in logs.items %}
        <li><span style="margin-right: 10px;">{{ log.date.strftime('%d %b %Hh%M') }}</span><span>{{ log.text|safe }} par
                {{ log.authenticated_user|get_nomcomplet_by_username }}</span></li>
        {% endfor %}
    </ul>

    <div class="text-center">
        <a href="{{ url_for('entreprises.logs', page=logs.prev_num) }}"
            class="btn btn-default {% if logs.page == 1 %}disabled{% endif %}">
            &laquo;
        </a>
        {% for page_num in logs.iter_pages(left_edge=1, right_edge=1, left_current=1, right_current=2) %}
        {% if page_num %}
        {% if logs.page == page_num %}
        <a href="{{ url_for('entreprises.logs', page=page_num) }}" class="btn btn-inverse">{{ page_num }}</a>
        {% else %}
        <a href="{{ url_for('entreprises.logs', page=page_num) }}" class="btn btn-default">{{ page_num }}</a>
        {% endif %}
        {% else %}
        ...
        {% endif %}
        {% endfor %}
        <a href="{{ url_for('entreprises.logs', page=logs.next_num) }}"
            class="btn btn-default {% if logs.page == logs.pages %}disabled{% endif %}">
            &raquo;
        </a>
    </div>

    <p class="text-center">
        Page {{ logs.page }} sur {{ logs.pages }}
    </p>
    {% else %}
    <div>Aucune opération</div>
    {% endif %}
</div>


{% endblock %}

app/templates/entreprises/logs_entreprise.j2
{# -*- mode: jinja-html -*- #}
{% extends 'base.j2' %}

{% block app_content %}
<div class="container">
    <ul class="breadcrumbs">
        <li class="breadcrumbs_item">
            <a href="{{ url_for('entreprises.index') }}" class="breadcrumbs_link">Entreprises</a>
        </li>
        <li class="breadcrumbs_item">
            <a href="{{ url_for('entreprises.fiche_entreprise', entreprise_id=entreprise.id) }}"
                class="breadcrumbs_link">Fiche entreprise</a>
        </li>
        <li class="breadcrumbs_item">
            <a href="" class="breadcrumbs_link breadcrumbs_link-active">Dernières opérations</a>
        </li>
    </ul>
</div>

<div class="container">
    <h3>Dernières opérations - {{ entreprise.nom }}</h3>
    {% if logs.items %}
    <ul>
        {% for log in logs.items %}
        <li><span style="margin-right: 10px;">{{ log.date.strftime('%d %b %Hh%M') }}</span><span>{{ log.text|safe }} par
                {{ log.authenticated_user|get_nomcomplet_by_username }}</span></li>
        {% endfor %}
    </ul>

    <div class="text-center">
        <a href="{{ url_for('entreprises.logs_entreprise', entreprise_id=entreprise.id, page=logs.prev_num) }}"
            class="btn btn-default {% if logs.page == 1 %}disabled{% endif %}">
            &laquo;
        </a>
        {% for page_num in logs.iter_pages(left_edge=1, right_edge=1, left_current=1, right_current=2) %}
        {% if page_num %}
        {% if logs.page == page_num %}
        <a href="{{ url_for('entreprises.logs_entreprise', entreprise_id=entreprise.id, page=page_num) }}"
            class="btn btn-inverse">{{ page_num }}</a>
        {% else %}
        <a href="{{ url_for('entreprises.logs_entreprise', entreprise_id=entreprise.id, page=page_num) }}"
            class="btn btn-default">{{ page_num }}</a>
        {% endif %}
        {% else %}
        ...
        {% endif %}
        {% endfor %}
        <a href="{{ url_for('entreprises.logs_entreprise', entreprise_id=entreprise.id, page=logs.next_num) }}"
            class="btn btn-default {% if logs.page == logs.pages %}disabled{% endif %}">
            &raquo;
        </a>
    </div>

    <p class="text-center">
        Page {{ logs.page }} sur {{ logs.pages }}
    </p>
    {% else %}
    <div>Aucune opération</div>
    {% endif %}
</div>

{% endblock %}

app/templates/entreprises/nav.j2
{# -*- mode: jinja-html -*- #}
<div class="container">
    <nav class="nav_entreprise">
        <ul>
            <li class="nav_entreprise_item">
                <a href="{{ url_for('entreprises.index') }}" class="nav_entreprise_link {% if title=='Entreprises' %}nav_entreprise_link-active{% endif %}">Entreprises</a>
            </li>

            {% if current_user.has_permission(current_user.Permission.RelationsEntrepViewCorrs, None) %}
            <li class="nav_entreprise_item">
                <a href="{{ url_for('entreprises.correspondants') }}" class="nav_entreprise_link {% if title=='Correspondants' %}nav_entreprise_link-active{% endif %}">Correspondants</a>
            </li>
            {% endif %}

            <li class="nav_entreprise_item">
                <a href="{{ url_for('entreprises.offres_recues') }}" class="nav_entreprise_link {% if title=='Offres reçues' %}nav_entreprise_link-active{% endif %}">Offres reçues</a>
            </li>

            {% if current_user.has_permission(current_user.Permission.RelationsEntrepValidate, None) %}
            <li class="nav_entreprise_item">
                <a href="{{ url_for('entreprises.validation') }}" class="nav_entreprise_link {% if title=='Validation entreprises' %}nav_entreprise_link-active{% endif %}">Entreprises à valider</a>
            </li>
            <li class="nav_entreprise_item">
                <a href="{{ url_for('entreprises.preferences') }}" class="nav_entreprise_link {% if title=='Préférences' %}nav_entreprise_link-active{% endif %}">Préférences</a>
            </li>
            {% endif %}
        </ul>
    </nav>
</div>

app/templates/entreprises/offres_expirees.j2
{# -*- mode: jinja-html -*- #}
{% extends 'base.j2' %}

{% block app_content %}
<div class="container">
    <ul class="breadcrumbs">
        <li class="breadcrumbs_item">
            <a href="{{ url_for('entreprises.index') }}" class="breadcrumbs_link">Entreprises</a>
        </li>
        <li class="breadcrumbs_item">
            <a href="{{ url_for('entreprises.fiche_entreprise', entreprise_id=entreprise.id) }}"
                class="breadcrumbs_link">Fiche entreprise</a>
        </li>
        <li class="breadcrumbs_item">
            <a href="" class="breadcrumbs_link breadcrumbs_link-active">Offres expirées</a>
        </li>
    </ul>
</div>

<div class="container">
    <h1>Offres expirées - {{ entreprise.nom }}</h1>
    {% if offres_expirees %}
    {% for offre, files, offre_depts, correspondant in offres_expirees %}
    {% include 'entreprises/_offre.j2' %}
    {% endfor %}
    {% else %}
    <div>Aucune offre expirées</div>
    {% endif %}
</div>
{% endblock %}

app/templates/entreprises/offres_recues.j2
{# -*- mode: jinja-html -*- #}
{% extends 'base.j2' %}

{% block app_content %}
{% include 'entreprises/nav.j2' %}

<div class="container">
    <h1>Offres reçues</h1>
    {% if offres_recues %}
    {% for envoi_offre, offre, files, correspondant in offres_recues %}
    <div class="offre offre-recue">
        <div style="word-break:break-all; text-align: justify;">
            Envoyé le {{ envoi_offre.date_envoi.strftime('%d/%m/%Y') }} à {{ envoi_offre.date_envoi.strftime('%Hh%M') }}
            par {{ envoi_offre.sender_id|get_nomcomplet_by_id }}<br>
            Intitulé : {{ offre.intitule }}<br>
            Description : {{ offre.description }}<br>
            Type de l'offre : {{ offre.type_offre }}<br>
            Missions : {{ offre.missions }}<br>
            Durée : {{ offre.duree }}<br>

            {% if offre.correspondant_id %}
            Contacté {{ correspondant.nom }} {{ correspondant.prenom }}
            {% if correspondant.mail and correspondant.telephone %}
            ({{ correspondant.mail }} - {{ correspondant.telephone }})
            {% else %}
            ({{ correspondant.mail }}{{ correspondant.telephone }})
            {% endif %}
            {% endif %}

            {% if correspondant.poste %}
            - poste : {{ correspondant.poste }}
            {% endif %}
            {% if correspondant.service %}
            - service : {{ correspondant.service }}
            {% endif %}
            <br>

            <a href="{{ url_for('entreprises.fiche_entreprise', entreprise_id=offre.entreprise_id) }}">lien vers
                l'entreprise</a><br>

            {% for filedir, filename in files %}
            <a
                href="{{ url_for('entreprises.get_offre_file', entreprise_id=offre.entreprise_id, offre_id=offre.id, filedir=filedir, filename=filename) }}">{{
                filename }}</a><br>
            {% endfor %}
        </div>
        <div>
            <a href="{{ url_for('entreprises.delete_offre_recue', envoi_offre_id=envoi_offre.id) }}"
                style="margin-left: 5px;"><img title="Supprimer" alt="supprimer" width="16" height="16" border="0"
                    src="/ScoDoc/static/icons/delete_small_img.png" /></a>
        </div>
    </div>
    {% endfor %}
    {% else %}
    <div>Aucune offre reçue</div>
    {% endif %}
</div>
{% endblock %}

app/templates/entreprises/preferences.j2
{# -*- mode: jinja-html -*- #}
{% extends 'base.j2' %}
{% import 'wtf.j2' as wtf %}

{% block app_content %}
{% include 'entreprises/nav.j2' %}

<div class="container">
    <h1>Préférences module gestion entreprises</h1>
    <br>
    <div class="row">
        <div class="col-md-4">
            {{ wtf.quick_form(form, novalidate=True) }}
        </div>
    </div>
</div>
{% endblock %}